#ifndef CTL_H
#define CTL_H


struct CTL_Thread
{
	void (*thread_function)(CTL_Thread *); // The "tick" function
	int wakeup; // When to wake up -- every X cycles: 1 is the fastests (every cycle)
	void *state; // Thread state -- can by anything.
	struct CTL_Thread *next; // A pointer to the next thread
};


CTL_Thread *ctl_thread_new( void (*thread_function)(CTL_Thread *), void *state, int wakeup);
void ctl_thread_add( CTL_Thread *thread, CTL_Thread *next);
int ctl_thread_del( CTL_Thread *thread, CTL_Thread *to_delete);
void ctl_thread_set_wakeup( CTL_Thread *thread, int wakeup);

#endif
